/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents fields that are compatible to be selected for a report of type
 * "CROSS_DIMENSION_REACH".
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CrossDimensionReachReportCompatibleFields extends GenericJson {

  /**
   * Dimensions which are compatible to be selected in the "breakdown" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Dimension> breakdown;

  static {
    // hack to force ProGuard to consider Dimension used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Dimension.class);
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Dimension> dimensionFilters;

  static {
    // hack to force ProGuard to consider Dimension used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Dimension.class);
  }

  /**
   * The kind of resource this is, in this case
   * dfareporting#crossDimensionReachReportCompatibleFields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Metric> metrics;

  static {
    // hack to force ProGuard to consider Metric used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Metric.class);
  }

  /**
   * Metrics which are compatible to be selected in the "overlapMetricNames" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Metric> overlapMetrics;

  static {
    // hack to force ProGuard to consider Metric used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Metric.class);
  }

  /**
   * Dimensions which are compatible to be selected in the "breakdown" section of the report.
   * The value returned may be {@code null}.
   */
  public java.util.List<Dimension> getBreakdown() {
    return breakdown;
  }

  /**
   * Dimensions which are compatible to be selected in the "breakdown" section of the report.
   * The value set may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields setBreakdown(java.util.List<Dimension> breakdown) {
    this.breakdown = breakdown;
    return this;
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * The value returned may be {@code null}.
   */
  public java.util.List<Dimension> getDimensionFilters() {
    return dimensionFilters;
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * The value set may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields setDimensionFilters(java.util.List<Dimension> dimensionFilters) {
    this.dimensionFilters = dimensionFilters;
    return this;
  }

  /**
   * The kind of resource this is, in this case
   * dfareporting#crossDimensionReachReportCompatibleFields.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case
   * dfareporting#crossDimensionReachReportCompatibleFields.
   * The value set may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * The value returned may be {@code null}.
   */
  public java.util.List<Metric> getMetrics() {
    return metrics;
  }

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * The value set may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields setMetrics(java.util.List<Metric> metrics) {
    this.metrics = metrics;
    return this;
  }

  /**
   * Metrics which are compatible to be selected in the "overlapMetricNames" section of the report.
   * The value returned may be {@code null}.
   */
  public java.util.List<Metric> getOverlapMetrics() {
    return overlapMetrics;
  }

  /**
   * Metrics which are compatible to be selected in the "overlapMetricNames" section of the report.
   * The value set may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields setOverlapMetrics(java.util.List<Metric> overlapMetrics) {
    this.overlapMetrics = overlapMetrics;
    return this;
  }

}
