/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents a DimensionValue resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DimensionValue extends GenericJson {

  /**
   * The name of the dimension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String dimensionName;

  /**
   * The eTag of this response for caching purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * The ID associated with the value if available.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * The kind of resource this is, in this case dfareporting#dimensionValue.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Determines how the 'value' field is matched when filtering. One of: - EXACT (default if not
   * specified)  - CONTAINS  - BEGINS_WITH  - WILDCARD_EXPRESSION (allowing '*' as a placeholder for
   * variable length character sequences, it can be escaped with a backslash.)  Note, only paid
   * search dimensions ('dfa:paidSearch*') allow a matchType other than EXACT.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String matchType;

  /**
   * The value of the dimension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String value;

  /**
   * The name of the dimension.
   * The value returned may be {@code null}.
   */
  public String getDimensionName() {
    return dimensionName;
  }

  /**
   * The name of the dimension.
   * The value set may be {@code null}.
   */
  public DimensionValue setDimensionName(String dimensionName) {
    this.dimensionName = dimensionName;
    return this;
  }

  /**
   * The eTag of this response for caching purposes.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * The eTag of this response for caching purposes.
   * The value set may be {@code null}.
   */
  public DimensionValue setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The ID associated with the value if available.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * The ID associated with the value if available.
   * The value set may be {@code null}.
   */
  public DimensionValue setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind of resource this is, in this case dfareporting#dimensionValue.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#dimensionValue.
   * The value set may be {@code null}.
   */
  public DimensionValue setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Determines how the 'value' field is matched when filtering. One of: - EXACT (default if not
   * specified)  - CONTAINS  - BEGINS_WITH  - WILDCARD_EXPRESSION (allowing '*' as a placeholder for
   * variable length character sequences, it can be escaped with a backslash.)  Note, only paid
   * search dimensions ('dfa:paidSearch*') allow a matchType other than EXACT.
   * The value returned may be {@code null}.
   */
  public String getMatchType() {
    return matchType;
  }

  /**
   * Determines how the 'value' field is matched when filtering. One of: - EXACT (default if not
   * specified)  - CONTAINS  - BEGINS_WITH  - WILDCARD_EXPRESSION (allowing '*' as a placeholder for
   * variable length character sequences, it can be escaped with a backslash.)  Note, only paid
   * search dimensions ('dfa:paidSearch*') allow a matchType other than EXACT.
   * The value set may be {@code null}.
   */
  public DimensionValue setMatchType(String matchType) {
    this.matchType = matchType;
    return this;
  }

  /**
   * The value of the dimension.
   * The value returned may be {@code null}.
   */
  public String getValue() {
    return value;
  }

  /**
   * The value of the dimension.
   * The value set may be {@code null}.
   */
  public DimensionValue setValue(String value) {
    this.value = value;
    return this;
  }

}
